#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: David Worrall
date: Created on Sun Dec 13 17:25:22 2020

<body width="700" height="480" topmargin="0" leftmargin="0" style="color: rgb(0, 0, 0); background-color: rgb(0, 0, 0);" marginheight="0" marginwidth="0">
<!-- BACKGROUND="images/bggrey2.jpg"-->
<p>
<table border="0" cellpadding="0" cellspacing="0" height="675" width="700">
  <tbody>
    <tr>
      <td width="700">
      <table bgcolor="#990066" border="0" cellpadding="0" cellspacing="0" height="100%" width="100%">
        <tbody>
          <tr width="100%">
            <td background="images/logobrainB.gif" height="122" width="100%">
            <p valign="top" align="center"><font color="#003399" face="Times New Roman" size="6"><b><br>
            </b></font><font color="#ffffff" face="Times New Roman" size="6"><b>MIND
THE MARKETS</b></font> <br>
            <font color="#ffffff" face="Times New Roman" size="4"><b>Education
for Financial Independence</b></font> </p>
 
"""
from demographicData import demographicDict
#print (demographicDict.keys())
#for kee in demographicDict.keys():

#for kee in covidInstanceDict2.keys():
#    print (covidInstanceDict2[kee].max)
    # use covidInstanceDict or covidInstanceDict2 or DeathsDB
# generate html pages for the Covid-19 site
# test using tattag: https://www.yattag.org
# pip install yattag

from covid19class import *                                                      # to pull in the dataSets. Need the class stuff?

from datetime import date
from yattag import Doc
doc, tag, text, line = Doc().ttl()   # equiv to doc = Doc(); tag = doc.tag; text = doc.text etc
def makePageBanner():
    with tag ('table',  "border:1; cellpadding :0; cellspacing:0; width: 900;height: 400;"):
        with tag ('tr'):
            with tag('td', width='300'):
                with tag ('img', src="./covid19_images/23354_lores.jpg", alt="left image", height="200" ):
                    pass
            with tag('td', width='300'):
#                with tag ('img', src="./covid19_images/23312_lores.jpg", alt="center image", height="200" ):
                with tag ('img', src="./covid19_images/coronavirus_multiple.jpg", alt="center image", height="200" ):
                    pass
            with tag('td', width='300'):
                with tag ('img', src="./covid19_images/Novel_Coronavirus_SARS-CoV-2.jpg", alt="right image", height="200" ):
                    pass
"""        with tag ('tr'):
            with tag('td', width='300'):
                with tag ('img', src="./covid19_images/covid_halfCrown_noBG.jpg", alt="left image", height="200" ):
                    pass
            with tag('td', width='300'):
#                with tag ('img', src="./covid19_images/23312_lores.jpg", alt="center image", height="200" ):
                with tag ('img', src="./covid19_images/Coronavirus-Germs.png", alt="center image", height="200" ):
                    pass
            with tag('td', width='300'):
                with tag ('img', src="./covid19_images/covid_wsurface.jpg", alt="right image", height="200" ):
                    pass
"""
deathFreeProvinces.sort()
provinceCol = 0
countryNameCol = 1
provincesList = list (provinceDeathsDict.keys())
provincesList.sort()
noDeathsStr = ""
for prov in provincesList: 
    if prov in deathFreeProvinces:
        if provinceDeathsDict[prov][provinceCol] == provinceDeathsDict[prov][countryNameCol]:   # the province is a country
            noDeathsStr += ', '+ provinceDeathsDict[prov][provinceCol]                      # add Country name
        else:                                                                               # add [Country] to Province listig
            noDeathsStr += ', '+ provinceDeathsDict[prov][provinceCol] +' ['+provinceDeathsDict[prov][countryNameCol]+']' 
if noDeathsStr[:2] == ', ':
    noDeathsStr = noDeathsStr[2:]                                                           # drop a leading ', ' if it exists

def makeMenu():
    menuSpacer = '&nbsp; | &nbsp'
#    with tag ('table',  "border:1; cellpadding :1; cellspacing:4; width: 900;"):
    with tag ('table',  "border:1; cellpadding:1; cellspacing:'1' width:900;"):
        with tag ('tr'):
            with tag ('td'):
                text('Home')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./countries.html"):
                    text ('Countries (alphabetical)')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./provinces.html"):
                    text('States/Provinces: raw')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./regions.html"):
                    text('Geographical regions')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./latitude.html"):
                    text('Latitude-adjusted')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./densities.html"):
                    text('Density-adjusted')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./otherCauses.html"):
                    text('cause comparisons')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./data.html"):
                    text('Data')
                doc.asis(menuSpacer)
            with tag ('td'):
                with tag('a', href="./references.html"):
                    text('References')

# ================ end of menu definition =====================================
# ================ color-coding stuff =========================================
from colorTables import colorBreakpoints # a table used to differentiate different max. daily death numbers for a province

def getTableColors(breakpoints=colorBreakpoints):
    # sets up the matplotlib legend table to itemize (by default) a color table
    # of max deaths/day - as set in the colorBreakpoints list
    legendColors = []
    legendLabels = []
    lowerLimit = 0                                                            # charts not generated for 0 deaths
    for indx in range (len (breakpoints)):
        legendColors += [colorBreakpoints[indx][2]]                         
        legendLabels += [str(lowerLimit+1)+' to ' + str(colorBreakpoints[indx][0])] # the lower limit of this color's range
        lowerLimit = breakpoints[indx][0]
        if indx == len (breakpoints) -1:                                       # kluge to change last label
            legendLabels[-1] = str (breakpoints[-2][0]+1)+' & above'
    return legendColors, legendLabels

legendColors, legendLabels = getTableColors()
#print ("legendColors:", legendColors)
#print ("legendLabels:", legendLabels)

def showColorTable():
    with tag ('center'):
        with tag ('table',  border="1px", style="background-color:#FFFFFF;"):
#            with tag ('caption'):
#                text ("Table of color-codes for max. nr. deaths/days.")
            with tag('tr'):
                with tag ('th'):
                    text('Color')
                with tag ('th'):
                    text ('Max. Daily Death rate')
            
            for colorNr in range (len (colorBreakpoints)):
                with tag ('tr'):
                    with tag('td', width='70', style="background-color:"+legendColors[colorNr]+";"):
                        pass #text(str(colorNr))
                    with tag('td', width='70', style="text-align:right;"):
                        text ( legendLabels[colorNr])
        text (" Table of color-codes used to indicate")
        doc.asis('<br>')
        text (" the max daily death rate for a Province.")
        doc.asis('<br>')

# ==================== PAGE SCRIPT STARTS HERE ================================
doc.asis ('<!DOCTYPE html>')
doc.asis('\n')
with tag('html'):
    doc.asis('\n')
    with tag ('head'):
        doc.asis('\n')
        with tag ('title'):
            text('COVID-19 Perceptualization')
        doc.asis('\n')
        with tag('style'):
            text('\n')
            text('body {'
                    +'\nbackground-color: #f0f8f0;'
                    +'\ncolor: black;'
                    + 'font-size:12px;'
                    + 'width: 900px;'
                    + 'topmargin: 0;' 
                    + 'leftmargin: 0;' 
#                    + 'height:480px;'
#                    + 'style=font-size:12px; color:red; font-weight:normal; font-style:plain; color: rgb(1, 1, 1);'
#                    +'background-color: rgb(88, 88,88;'
                    + 'marginheight:0; marginwidth:0;'
                    + '}'
                    )
    doc.asis('\n')
# ==================== PAGE <BODY> STARTS HERE ================================    
    with tag('body'):
        doc.asis('\n<center>\n')
        makePageBanner()
        makeMenu()
# ===================================== <Titles> ============================f
        with tag('h1'):
            text('A Comparative Perceptualization Study\n')
            doc.asis('<br>')
            text('\nof Global Death Data attributed to')
            doc.asis('\n<br>')
            text('\nCoronavirus Disease 2019 (COVID-19)')
            doc.asis('\n<br>')
            text('\nand other factors\n')
#        doc.asis('\n')
        with tag('h2'):
            text('\nsonifications and visualizations\n')
        with tag('h3'):
            text('by')
        with tag('h2'):
            text("David Worrall")
        with tag('h3'):
            text('Audio Arts and Acoustics Department')
            doc.asis('<br>')
            text(' Columbia College Chicago')
        with tag('h4'):
            text('dworrall_at_colum_dot_edu')            
            datee = str(date.today())   # international/financial format
            doc.asis('<br>')
            text('Last updated: '+datee)
        doc.asis('\n</center>\n')
# =============================== </Titles> =================================
# =============================== <Intro> =====================================
        with tag('h3'):
            text('\nIntroduction\n')
#        doc.asis('\n')
        with tag ('p'):
            text('Coronavirus Disease 2019 (COVID-19) is a contagious disease caused by severe acute respiratory syndrome'
                 + ' coronavirus 2 (SARS-CoV-2).'
                 + ' The first case was identified in Wuhan, China, in December 2019.' 
                 +' It has since spread worldwide, leading to an ongoing pandemic that spread globally in 2020.')
        with tag ('p'):
            text('\nThis is a polymedia perceptualization study of data, reported daily,' )
            text(' of global deaths that have been attributed to COVID-19. \n')
        with tag ('p'):
            text(' The data is...')
            text(' Some more guff about the methods etc')
            with tag('td',
                     ('data-search', 'lemon'),
                     ('data-order', '1384'),
                     id = '16'
                     ):
                text('Citrus Limon')

# =============================== No Deaths ===================================
        with tag('h3'):
            text('\n Provinces with no deaths due to Covid-19 reported')
        doc.asis('\n')
        with tag ('p'):
            text('Of the '+ str(len(provinceDeathsDict)) +' provinces tracked in this study, ')
            text (' the following ' + str(len (deathFreeProvinces)) + ' are reported as having NO deaths due to Covid-19:')
            doc.asis('\n<br>\n')
            text (noDeathsStr +'.')

# ================ Provinces reporting Deaths due to Covid-19. ================
        with tag('h3'):               
            text('\nProvinces reporting Deaths due to Covid-19')
        doc.asis('\n')
        with tag ('p'):
            text('Because of the wildly varying ways in which this virus spread globally,' )
            text(' and the methods exployed to attempt to control the spread within Provinces has also varied,')
            text(' Provinces have been grouped in various ways.')
            text(' The principle grouping is by color-coding their daily chart according to the maximum number') 
            text(' of deaths in any one day, as follows:')
        showColorTable()  

# ================ Groupings of Provinces ================
        with tag('h3'):
            text('\n Types of Province/Country groupings on this Site ')
        doc.asis('\n')
        with tag('h4'):
            text('\n Alphabetical Listing by Province/Country name')
            alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
        with tag ('ul'):
            for letter in alphabet:
                with tag ('li'):
                    doc.asis('<bold><br>'+letter+ ' : </bold>')
#                    text (letter + ' : ')
                    text ('Comma-separated provinces beginning with '+letter)
                                                     # defined aboce 
# =============================== <References> ================================
        doc.asis('\n')
        with tag('h3'):
            text ('References')
 
        doc.asis('\n')
        with tag('h4'):
            text ('Statistical Data')

        doc.asis('<br>')
        text('John Hopkins University Data:')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' COVID-19 Data Repository by the Center for Systems Science and Engineering (CSSE). https://github.com/CSSEGISandData/COVID-19 ')

        doc.asis('<br>')
        text('The Covid Tracking Project:')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' Reportedly, the most complete data available about COVID-19 in the US.')
        text(' https://covidtracking.com/')

        text('World Country/State Data:')
        doc.asis('&emsp;John Hopkins University, via https://data.world/shad/covid-19-time-series-data/')

        doc.asis('<br>')
        text('US State Data:')
        doc.asis('&nbsp;&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp;&emsp;')
        text(' NewYork Times: https://github.com/nytimes/covid-19-data/blob/master/us-states.csv')

        doc.asis('<br>')
        text('US County Data:')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' NewYork Times: https://github.com/nytimes/covid-19-data/blob/master/us-counties.csv')
        
        doc.asis('<br>')
        text('Geographic & Demographic Data:')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' Internet Usage Statistics: https://www.internetworldstats.com/stats.htm and https://www.internetworldstats.com/list3.htm')

        doc.asis('<br>')
        text('World Factbook Data:')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' https://www.cia.gov/library/publications/download')

        doc.asis('\n')
        with tag('h4'):
            text ('Programming tools')

        doc.asis('<br>')
        text('Le Forestier, B. 202??')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' Yattag: A Python library for generating HTML or XML in a pythonic way.')
        text(' https://www.yattag.org/')

        doc.asis('<br>')
        text('Huang,Xianxian, 2019.')
        text(' Anomoly Detection for Python:')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' https://github.com/Marcnuth/AnomalyDetection')
        doc.asis('<br>')
        text(' See also his: Genetic Algorithm in Python, which could be used for Sampling, Feature Select, Model Select, etc in Machine Learning' )
        text(' https://github.com/Marcnuth/genetics')

        doc.asis('<br>')
        text('Kejariwal‎, A. 2015.')
        text(' Introducing practical and robust anomaly detection in a time series.')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' https://blog.twitter.com/engineering/en_us/a/2015/introducing-practical-and-robust-anomaly-detection-in-a-time-series.html')

        doc.asis('\n')
        with tag('h4'):
            text ('Other useful resources')

        doc.asis('<br>')
        text('Seheult, R. 2020.')
        doc.asis('&nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp; ')
        text(' The role of `Vitamin D in Covid-19.')
        text(' Vitamin D and COVID 19: The Evidence for Prevention and Treatment of Coronavirus (SARS CoV 2)')
        text(' https://www.youtube.com/watch?v=ha2mLz-Xdpg')


        with tag('p', style="font-size:14px; color:red; font-weight:bold; font-style:bold;"):
            text('  An example of ')          
            with tag('span', style ="color:green; font-size:20px;" ):
                text (' changing COLOR')
            doc.asis('<br>') 
            text(' and ...')
            with tag('span', style= "color: #0000a0; font-size:20px;" ):
                text (' another!')
            text (' and so forth ...')
        text('Easy as Pie!')
            
                    
        
        
#print(doc.getvalue())
indexpage = open (websiteDirectory+'index.html', 'w')
indexpage.write (doc.getvalue())
indexpage.close()



# ====================  Reference materials ==================================
"""
1. Databases
3. geographic and demographic 

2. covid-19 websites

The 2020 geographic population data is from the INTERNET USAGE STATISTICS website which also has land-area:
https://www.internetworldstats.com/stats.htm
https://www.internetworldstats.com/list3.htm
World regions and old stats on reported cases (not deaths) in April 2020:\
        Africa
        Asia
        Central America
        Eastern Europe
        European Union
        Middle East
        North America
        Oceania
        South America
        The Caribbean

        AFRICA
        Eastern Africa
        Burundi - 405 cases-Aug 9/20, (5 cases April 20/20)
        Comoros - 399 cases-Aug 9/20, (no data April 20/20)
        Djibouti - 5,338 cases-Aug 9/20, (846 cases-Apr20/20)
        Eritrea - 285 cases-Aug 9/20, (39 cases-Apr20/20)
        Ethiopia - 22,253 cases-Aug 9/20, (108 cases-Apr20/20)
        Kenya - 25,837 cases-Aug 9/20, (270 cases-Apr20/20)
        Madagascar - 13,086 cases-Aug 9/20, (121 cases-Apr20/20)
        Malawi - 4,624 cases-Aug 9/20, (17 cases-Apr20/20)
        Mauritius - 344 cases-Aug 9/20, (328 cases-Apr20/20)
        Mayotte - 3,068 cases-Aug 9/20, (271 cases-Apr20/20)
        Mozambique - 2,241 cases-Aug 9/20, (39 cases-Apr20/20)
        Reunion - 681 cases-Aug 9/20, (408 cases-Apr20/20)
        Rwanda - 2,134 cases-Aug 9/20, (147 cases-Apr20/20)
        Seychelles - 126 cases-Aug 9/20, (11 cases-Apr20/20)
        Somalia - 3,227 cases-Aug 9/20, (164 cases-Apr20/20)
        Tanzania - 509 cases-Aug 9/20, (170 cases-Apr20/20)
        Uganda - 1,267 cases-Aug 9/20, (55 cases-Apr20/20)
        Zambia - 8,085 cases-Aug 9/20, (61 cases-Apr20/20)
        Zimbabwe - 4,575 cases-Aug 9/20, (25 cases-Apr20/20)

        Middle Africa
        Angola - 1,572 cases-Aug 9/20, (24 cases-Apr20/20)
        Cameroon - 18,042 cases-Aug 9/20, (1,017 cases-Apr20/20)
        CAR - 4,641 cases-Aug 9/20, (12 cases-Apr20/20)
        Chad - 942 cases-Aug 9/20, (33 cases-Apr20/20)
        Congo (Brazza) - 3,664 cases-Aug 9/20, (143 cases-Apr20/20)
        Congo, D. R. - 9,454 cases-Aug 9/20, (327 cases-Apr20/20)
        Equatorial Guinea - 4,821 cases-Aug 9/20, (79 cases-Apr20/20)
        Gabon - 7,923 cases-Aug 9/20, (109 cases-Apr20/20)
        Sao Tome and Princ - 878 cases-Aug 9/20, (4 cases-Apr20/20)

        Northern Africa
        Algeria - 34,693 cases-Aug 9/20, (2,629 cases-Apr20/20)
        Egypt - 95,314 cases-Aug 9/20, (3,144 cases-Apr20/20)
        Libya - 5,232 cases-Aug 9/20, (51 cases-Apr20/20)
        Morroco - 32,007 cases-Aug 9/20, (2,855 cases-Apr20/20)
        South Sudan - 2,463 cases-Aug 9/20, (4 cases-Apr20/20)
        Sudan - 11,894 cases-Aug 9/20, (92 cases-Apr20/20)
        Tunisia - 1,678 cases-Aug 9/20, (879 cases-Apr20/20)
        Western Sahara - 10 cases-Aug 9/20, (6 cases-Apr20/20)

        Southern Africa
        Botswana - 804 cases-Aug 9/20, (20 cases-Apr20/20)
        Eswatini - 3,128 cases-Aug 9/20, (22 cases-Apr20/20)
        Lesotho - 742 cases-Aug 9/20, (no data-Apr20/20)
        Namibia - 2,802 cases-Aug 9/20, (16 cases-Apr20/20)
        South Africa - 553,188 cases-Aug 9/20, (3,158 cases-Apr20/20)

        Western Africa
        Benin - 1,936 cases-Aug 9/20, (35 cases-Apr20/20)
        Burkina Faso - 1,175 cases-Aug 9/20, (576 cases-Apr20/20)
        Cape Verde - 2,835 cases-Aug 9/20, (61 cases-Apr20/20)
        Cote d'Ivoire - 16,620 cases-Aug 9/20, (847 cases-Apr20/20)
        Gambia - 1,090 cases-Aug 9/20, (10 cases-Apr20/20)
        Ghana - 41,003 cases-Aug 9/20, (1,042 cases-Apr20/20)
        Guinea - 7,875 cases-Aug 9/20, (579 cases-Apr20/20)
        Guinea-Bissau - 2,052 cases-Aug 9/20, (50 cases-Apr20/20)
        Liberia - 1,234 cases-Aug 9/20, (91 cases-Apr20/20)
        Mali - 2,565 cases-Aug 9/20, (224 cases-Apr20/20)
        Mauritania - 6,510 cases-Aug 9/20, (7 cases-Apr20/20)
        Niger - 1,157 cases-Aug 9/20, (648 cases-Apr20/20)
        Nigeria - 46,140 cases-Aug 9/20, (627 cases-Apr20/20)
        Saint Helena - no cases-Aug 9/20, (no cases-Apr20/20)
        Senegal - 11,175 cases-Aug 9/20, (367 cases-Apr20/20)
        Sierra Leone - 1,895 cases-Aug 9/20, (35 cases-Apr20/20)
        Togo - 1,046 cases-Aug 9/20, (84 cases-Apr20/20)

        THE AMERICAS
        North America, Latin America and the Caribbean

        The Caribbean
        Anguilla - 3 cases-Aug 9/20, (3 cases-Apr10/20)
        Antigua and Barbuda - 92 cases-Aug 9/20, (21 cases-Apr10/20)
        Aruba - 86 cases-Aug 9/20, (86 cases-Apr10/20)
        Bahamas - 878 cases-Aug 9/20, (42 cases-Apr10/20)
        Barbados - 138 cases-Aug 9/20, (67 cases-Apr10/20)
        British Virgin Islands - 9 cases-Aug 9/20, (3 cases-Apr10/20)
        Caribbean Netherlands - 13 cases-Aug 9/20, (2 cases-Apr10/20)
        Cayman Islands - 203 cases-Aug 9/20, (45 cases-Apr10/20)
        Cuba - 2,888 cases-Aug 9/20, (564 cases-Apr10/20)
        Curaçao - 31 cases-Aug 9/20, (14 cases-Apr10/20)
        Dominica - 18 cases-Aug 9/20, (16 cases-Apr10/20)
        Dominican Rep 78,778 cases-Aug 9/20, (2,620 cases-Apr10/20)
        Grenada - 24 cases-Aug 9/20, (14 cases-Apr10/20)
        Guadeloupe - 290 cases-Aug 9/20, (143 cases-Apr10/20)
        Haiti - 7,599 cases-Aug 9/20, (31 cases-Apr10/20)
        Jamaica - 1,003 cases-Aug 9/20, (63 cases-Apr10/20)
        Martinique - 336 cases-Aug 9/20, (155 cases-Apr10/20)
        Monserrat - 9 cases-Aug 9/20, (9 cases-Apr10/20)
        Puerto Rico - 22,121 cases-Aug 9/20, (1,068 cases-Apr17/20)
        Saint-Barthélemy - 9 cases-Aug 9/20, (6 cases-Apr10/20)
        St. Kitts and Nevis - 12 cases-Aug 9/20, (12 cases-Apr10/20)
        Saint Lucia - 25 cases-Aug 9/20, (15 cases-Apr10/20)
        Saint Martin - 78 cases-Aug 9/20, (32 cases-Apr10/20)
        Saint Vincent and the Grenadines - 57 cases-Aug 9/20, (12 cases-Apr10/20)
        Sint Maarten - 177 cases-Aug 9/20, (50 cases-Apr10/20)
        Trinidad and Tobago - 275 cases-Aug 9/20, (114 cases-Apr20/20)
        Turks and Caicos Islands - 170 cases-Aug 9/20, (11 cases-Apr20/20)
        Virgin Islands (US) - 528 cases-Aug 9/20, (53 cases-Apr20/20)

        Central America
        Belize - 146 cases-Aug 9/20, (18 cases-Apr18/20)
        Costa Rica - 22,802 cases-Aug 9/20, (655 cases-Apr18/20)
        El Salvador - 20,423 cases-Aug 9/20, (190 cases-Apr18/20)
        Guatemala - 56,189 cases-Aug 9/20, (235 cases-Apr18/20)
        Honduras - 46,973 cases-Aug 9/20, (457 cases-Apr18/20)
        Mexico - 475,902 cases-Aug 9/20, (3,441 cases-Apr10/20)
        Nicaragua - 3,902 cases-Aug 9/20, (7 cases-Apr10/20)
        Panama - 73,651 cases-Aug 9/20, (2,974 cases-Apr10/20)

        South America
        Argentina - 241,811 cases-Aug 9/20, (2,571 cases-Apr16/20)
        Bolivia - 89,055 cases-Aug 9/20, (441 cases-Apr16/20)
        Brazil - 3,013,369 cases-Aug 9/20, (28,912 cases-Apr16/20)
        Chile - 371,023 cases-Aug 9/20, (8,273 cases-Apr16/20)
        Colombia - 376,870 cases-Aug 9/20, (3,105 cases-Apr16/20)
        Ecuador - 93,572 cases-Aug 9/20, (8,225 cases-Apr16/20)
        Falkland Islands - 13 cases-Aug 9/20, (11 cases-Apr16/20)
        French Guiana - 8,267 cases-Aug 9/20, (86 cases-Apr16/20)
        Guyana - 554 cases-Aug 9/20, (55 cases-Apr16/20)
        Paraguay - 6,705 cases-Aug 9/20, (174 cases-Apr16/20)
        Peru - 471,012 cases-Aug 9/20, (12,491 cases-Apr16/20)
        Suriname - 2,306 cases-Aug 9/20, (10 cases-Apr16/20)
        Uruguay - 1,335 cases-Aug 9/20, (493 cases-Apr16/20)
        Venezuela - 24,961 cases-Aug 9/20, (197 cases-Apr16/20)

        Northern America
        Bermuda - 157 cases-Aug 9/20, (81 cases-Apr16/20)
        Canada - 119,221 cases-Aug 9/20, (29,929 cases-Apr16/20)
        Greenland - 14 cases-Aug 9/20, (11 cases-Apr16/20)
        Saint Pierre & Miquelon - 4 case-Aug 9/20, (1 case-Apr16/20)
        United States - 5,150,757 cases-Aug 9/20, (678,210 cases-Apr17/20)

         ASIA
        Afganistan - 37,054 cases-Aug 9/20, (993 cases-Apr19/20)
        Armenia - 40,410 cases-Aug 9/20, (1,291 cases-Apr19/20)
        Azerbaijan - 33,568 cases-Aug 9/20, (1,373 cases-Apr19/20)
        Bangladesh - 257,600 cases-Aug 9/20, (2,456 cases-Apr19/20)
        Bhutan - 108 cases-Aug 9/20, (5 cases-Apr19/20)
        Brunei Darussalam - 142 cases-Aug 9/20, (136 cases-Apr14/20)
        Cambodia - 251 cases-Aug 9/20, (122 cases-Apr14/20)
        China - 84,619-Aug 9/20, (82,249-Apr14/20)
        Georgia - 1,225 cases-Aug 9/20, (296 cases-Apr14/20)
        Hong Kong - 4,080 cases-Aug 9/20, (1,013 cases-Apr14/20)
        India - 2,158,408 cases-Aug 9/20, (10,541 cases-Apr14/20)
        Indonesia - 125,396 cases-Aug 9/20, (6,575 cases-Apr19/20)
        Japan - 45,439 cases-Aug 9/20, (7,645 cases-Apr14/20)
        Kazakhstan - 98,701 cases-Aug 9/20, (1,202 cases-Apr14/20)
        Korea, North - no data
        Korea, South - 14,598 cases-Aug 9/20, (10,564 cases-Apr14/20)
        Kyrgyzstan - 39,919 cases-Aug 9/20, (430 cases-Apr14/20)
        Laos - 20 cases-Aug 9/20, (19 cases-Apr14/20)
        Macao - 46 cases-Aug 9/20, (45 cases-Apr14/20)
        Malaysia - 9,083 cases-Aug 9/20, (4,987 cases-Apr14/20)
        Maldives - 4,898 cases-Aug 9/20, (20 cases-Apr14/20)
        Mongolia - 293 cases-Aug 9/20, (30 cases-Apr14/20)
        Myanmar - 359 cases-Aug 9/20, (63 cases-Apr14/20)
        Nepal - 22,972 cases-Aug 9/20, (16 cases-Apr14/20)
        Pakistan - 284,121 cases-Aug 9/20, (5,837 cases-Apr14/20)
        Phillipines - 129,913 cases-Aug 9/20, (6,259 cases-Apr19/20)
        Singapore - 55,104 cases-Aug 9/20, (6,588 cases-Apr19/20)
        Sri Lanka - 2,841 cases-Aug 9/20, (219 cases-Apr14/20)
        Taiwan - 480 cases-Aug 9/20, (420 cases-Apr19/20)
        Tajikistan - 7,827 cases-Aug 9/20, (no data-Apr19/20)
        Thailand - 3,351 cases-Aug 9/20, (2,613 cases-Apr14/20)
        Timor Leste (West) - 25 cases-Aug 9/20, (6 cases-Apr14/20)
        Turkmenistan - no data-Aug 9/20,
        Uzbekistan - 30,197 cases-Aug 9/20, (1,113 cases-Apr14/20)
        Vietnam - 841 cases-Aug 9/20, (266 cases-Apr14/20)

        EUROPE
        Albania - 6,275 cases-Aug 9/20, (562 cases-Apr19/20)
        Andorra - 963 cases-Aug 9/20, (704 cases-Apr19/20)
        Belarus - 68,850 cases-Aug 9/20, (4,779 cases-Apr19/20)
        Bosnia-H - 13,687 cases-Aug 9/20, (1,285 cases-Apr19/20)
        Croatia - 5,604 cases-Aug 9/20, (1,534 cases-Apr12/20)
        Faroe Islands - 303 cases-Aug 9/20, (184 cases-Apr12/20)
        Gibraltar - 197 cases-Aug 9/20, (129 cases-Apr12/20)
        Guerney and Alderney - 597 cases-Aug 9/20, (407 cases-Apr12/20)
        Iceland - 1,955 cases-Aug 9/20, (1,689 cases-Apr12/20)
        Jersey - 347 cases-Aug 9/20, (81 cases-Apr12/20)
        Kosovo - no Data, see Serbia
        Liechtenstein - 79 cases-Aug 9/20, (79 cases-Apr12/20)
        Man, Island of - 336 cases-Aug 9/20, (226 cases-Apr12/20)
        Moldova - 27,443 cases-Aug 9/20, (1,560 cases-Apr12/20)
        Monaco - 131 cases-Aug 9/20, (92 cases-Apr12/20)
        Montenegro - 3,588 cases-Aug 9/20, (263 cases-Apr12/20)
        North Macedonia - 11,754 cases-Aug 9/20, (760 cases-Apr12/20)
        Norway - 9,599 cases-Aug 9/20, (6,409 cases-Apr12/20)
        Russia - 887,536 cases-Aug 9/20, (13,584 cases-Apr12/20)
        San Marino - 699 cases-Aug 9/20, (356 cases-Apr12/20)
        Serbia - 27,863 cases-Aug 9/20, (3,380 cases-Apr12/20)
        Svalbard and Jan Mayen Islands - no Data
        Switzerland - 36,603 cases-Aug 9/20, (25,107 cases-Apr12/20)
        Turkey - 239,622 cases-Aug 9/20, (56,956 cases-Apr12/20)
        Ukraine - 80,949 cases-Aug 9/20, (2,511 cases-Apr12/20)
        UK - 309,763 cases-Aug 9/20, (103,093 cases-Apr17/20)
        Vatican City - 12 cases-Aug 9/20, (8 cases-Apr12/20)

        EUROPEAN UNION
        Austria - 22,033 cases-Aug 9/20, (14,476 cases-Apr17/20)
        Belgium - 73,401 cases-Aug 9/20, (34,809 cases-Apr17/20)
        Bulgaria - 13,343 cases-Aug 9/20, (825 cases-Apr17/20)
        Cyprus - 1,233 cases-Aug 9/20, (735 cases-Apr17/20)
        Czechia - 18,235 cases-Aug 9/20, (6,433 cases-Apr17/20)
        Denmark - 14,442 cases-Aug 9/20, (6,879 cases-Apr17/20)
        Estonia - 2,152 cases-Aug 9/20, (1,434 cases-Apr17/20)
        Finland - 7,584 cases-Aug 9/20, (3,369 cases-Apr17/20)
        France - 197,921 cases-Aug 9/20, (165,027 cases-Apr17/20)
        Germany - 216,896 cases-Aug 9/20, (137,698 cases-Apr17/20)
        Greece - 5,421 cases-Aug 9/20, (2,207 cases-Apr17/20)
        Hungary - 4,696 cases-Aug 9/20, (1,763 cases-Apr17/20)
        Ireland - 26,644 cases-Aug 9/20, (13,271 cases-Apr17/20)
        Italy - 250,103 cases-Aug 9/20, (168,941 cases-Apr17/20)
        Latvia - 1,290 cases-Aug 9/20, (675 cases-Apr17/20)
        Lithuania - 2,252 cases-Aug 9/20, (1,128 cases-Apr17/20)
        Luxembourg - 7,169 cases-Aug 9/20, (3,444 cases-Apr17/20)
        Malta - 1,089 cases-Aug 9/20, (412 cases-Apr17/20)
        Netherlands - 57,987 cases-Aug 9/20, (29,214 cases-Apr17/20)
        Poland - 51,791 cases-Aug 9/20, (7,918 cases-Apr17/20)
        Portugal - 52,537 cases-Aug 9/20, (18,841 cases-Apr17/20)
        Romania - 61,768 cases-Aug 9/20, (7,707 cases-Apr17/20)
        Slovakia - 2,596 cases-Aug 9/20, (977 cases-Apr17/20)
        Slovenia - 2,247 cases-Aug 9/20, (1,268 cases-Apr17/20)
        Spain - 361,442 cases-Aug 9/20, (184,948 cases-Apr17/20)
        Sweden - 82,323 cases-Aug 9/20, (12,540 cases-Apr17/20)

        MIDDLE EAST
        Bahrain - 43,629 cases-Aug 9/20, (1,773 cases-Apr19/20)
        Iran - 326,712 cases-Aug 9/20, (82,211 cases-Apr19/20)
        Iraq - 147,389 cases-Aug 9/20, (1,513 cases-Apr19/20)
        Israel - 82,515 cases-Aug 9/20, (13,362 cases-Apr19/20)
        Jordan - 1,246 cases-Aug 9/20, (413 cases-Apr19/20)
        Kuwait - 71,199 cases-Aug 9/20, (1,915 cases-Apr19/20)
        Lebanon - 6,223 cases-Aug 9/20, (673 cases-Apr19/20)
        Oman - 81,580 cases-Aug 9/20, (1,266 cases-Apr19/20)
        Palestine - 14,205 cases-Aug 9/20, (431 cases-Apr19/20)
        Qatar - 112,947 cases-Aug 9/20, (5,448 cases-Apr19/20)
        Saudi Arabia - 287,262 cases-Aug 9/20, (8,274 cases-Apr19/20)
        Syria - 1,125 cases-Aug 9/20, (38 cases-Apr19/20)
        UAE - 62,525 cases-Aug 9/20, (6,781 cases-Apr19/20)
        Yemen - 1,797 case-Aug 9/20, (1 case-Apr19/20)

        OCEANIA
        Australia - 20,698 cases-Aug 9/20, (6,497 cases-Apr17/20)
        Fiji - 27 cases-Aug 9/20, (17 cases-Apr17/20)
        French Polynesia - 69 cases-Aug 9/20, (55 cases-Apr17/20)
        Guam (USA) - 411 cases-Aug 9/20, (135 cases-Apr17/20)
        Kiribati - no data
        Marshall Islands - no data
        Micronesia - no data
        New Caledonia - 23 cases-Aug 9/20, (18 cases-Apr17/20)
        New Zealand - 1,569 cases-Aug 9/20, (1,409 cases-Apr17/20)
        Northern Mariana Islands (USA) - 48 cases-Aug 9/20, (13 cases-Apr17/20)
        Samoa - no data
        Samoa, American - no data
        Solomon, Islands - no data
        Tonga - no data
        Vanuatu - no data

"""
# ============================== </Data sources> ==============================


"""
        with tag ('p'):
            text('  An example of ')          
            with tag('span',id ='style = color: green; font-size:20px;'):
                text (' changing COLOR')
            doc.asis('<br>')
            with tag('span', klass = 'color: #0000a0'):
                text (' and ...another.')
        text('Easy as pie!')

        doc.asis('\n')



<p style="font-size:14px; color:#538b01; font-weight:bold; font-style:italic;">
  Enter the competition by 
  <span style="color: #ff0000">January 30, 2011</span>
  and you could win up to $$$$ — including amazing 
  <span style="color: #0000a0">summer</span> 
  trips!
</p>
correspondence with author of yattag`: 2021 01 04

Hello David,

thanks for the compliments!

As for your question, there's not a particular function in Yattag to generate style instructions.
I'm afraid there's not going to be an easier way of doing this than:

with tag("p", style="font-size:14px; color:#538b01; font-weight:bold; font-style:bold;"):
    ...

If your documents use a lot of these styling attributes, maybe you could write a Style class to generate the style attributes? That could be a subclass of `dict`. And you could override the __str__ method so that it returns these styling strings that you can then pass to Yattag.

style = Style(font-size="14px", color="#538b01")
style['font-weight'] = 'bold'

with tag("p", style = str(style)):
    ...

Just an idea. There's not really a particular way of doing this with Yattag.

Have a nice day.

Benjamin


On Tue, 5 Jan 2021 05:51:40 +0000
"Worrall, David" <dworrall@colum.edu> wrote:

Hello, and thanks for a well-thought-out module!

I’m testing to see if it is useful in an algorithmically generated tag attribute application.
I have search the web, multiple example sites etc, looking for how to use yattag to code <style> characteristics, as exemplified by following:

<p style="font-size:14px; color:#538b01; font-weight:bold; font-style:bold;">
   An example of
   <span style="color: #ff0000">changing Colour etc.</span>
   including amazing
   <span style="color: #0000a0">other options</span>
   not before available`!
</p>

Any clue/URL reference would be most helpful.

Thanks for your consideration,

David
PS I also like your writing style – nicely balancing informal tone with  precise wording.

"""